// imports
//import geomerative.*;

//variables
int maxRadius = 10;
int minRadius = 1;
int maxCount = 500;
int counter = 0;
int globalShadowOffset = 1;
float shadowSize = 1.2;
Dot arr[] = new Dot[maxCount];
PShape drawing;
PImage img;
int dimension;

float speed = 0;
float gravity = 0.001;
float gFactor = 0.9;

float closestX;
float closestY;
float min = 9999999;

enum S {INIT, GRAVITY, CALCULATE};
S state = S.INIT;

color c;

// determines the curve
float exponent = 1; 

float globalStep = 0.05;
float pom = 0;

int fCounter = 0;

//initialize

void clear() {
  background(#042a2b);
}

void setup() {
  
  size(400, 372);
  clear();
  smooth();
  noStroke();
  
  //frameRate(30);
  
  img = loadImage("hloznik.jpeg");
  img.resize(width, height);
  image(img, width/2 - img.width/2, height/2 - img.height/2);
  //img.loadPixels();
  //dimension = img.width * img.height;
  
}

void draw() {
  
  if (state == S.INIT) {
    
    // draw background image
    //image(img, width/2 - img.width/2, height/2 - img.height/2);

    if (counter < maxCount) {
      arr[counter] = new Dot();
      arr[counter].render();
      counter++;
    } else {
      state = S.CALCULATE;
    }
    
  }
  
  else if (state == S.CALCULATE) {
    
    // draw frame not to flicker
    image(img, width/2 - img.width/2, height/2 - img.height/2);
    
    // calculate distances
    for (int i = 0; i < arr.length; i++) {
    
      // reset min distance
      min = 999999;
      
      // find closest pixel
      for (int j = 0; j < img.height; j++) {
        for (int k = 0; k < img.width; k++) {
          color cx = img.get(j, k);
          if (red(cx) < 220 && green(cx) < 220 && blue(cx) < 220) {
          //if (img.get(j, k) != color(255,255,255)) {
            
            float dd = dist(j, k, arr[i].x, arr[i].y);
            if (dd < min) {
              closestX = j;
              closestY = k;
              min = dd;
            }
          
          }
        }
      }
      
      // save position of closest pixel
      arr[i].closestPixel = new PVector(closestX, closestY);
      
    }
    
    // move on to the next state
    state = S.GRAVITY;
    
  }
  
  else if (state == S.GRAVITY) {
    
    // draw background image
    image(img, width/2 - img.width/2, height/2 - img.height/2);
    //background(#FFFFFF);
   
    // gravity kicks in
    for (int i = 0; i < arr.length; i++) {
      
      // draw line - DEBUG
      //stroke(5);
      //line(arr[i].x, arr[i].y, arr[i].closestPixel.x, arr[i].closestPixel.y);
      //noStroke();
      
      // redraw
      arr[i].redrawAt(arr[i].x, arr[i].y);
      
      // gravity
      arr[i].pct = arr[i].pct + arr[i].step;
      if (arr[i].pct < 1.0) {
        arr[i].x = arr[i].beginX + (arr[i].pct * (arr[i].closestPixel.x - arr[i].beginX));
        arr[i].y = arr[i].beginY + (pow(arr[i].pct, exponent) * (arr[i].closestPixel.y - arr[i].beginY));
      } else {
        arr[i].pct = 0.0;
        float pomx = arr[i].closestPixel.x;
        float pomy = arr[i].closestPixel.y;
        arr[i].closestPixel.x = arr[i].beginX;
        arr[i].closestPixel.y = arr[i].beginY;
        arr[i].beginX = pomx;
        arr[i].beginY = pomy;
        //arr[i].step += 0.001;
        
        arr[i].col = color((red(arr[i].col) + 5) % 255, 0, 0);
      }
      
      //// speed
      //arr[i].y = arr[i].y + arr[i].speed;
      //arr[i].x = arr[i].x + arr[i].speed;
      
      //// gravity + speed
      //arr[i].speed = arr[i].speed + gravity;
      
      //// reverse if hits the pixel
      //if (dist(arr[i].x, arr[i].y, arr[i].closestPixel.x, arr[i].closestPixel.y) < arr[i].radius) {
      //  arr[i].speed = arr[i].speed * gFactor * (-1);
      //  arr[i].x = arr[i].closestPixel.x;
      //  arr[i].y = arr[i].closestPixel.y;
      //}
    }
    
  }
  
  
  //else {
  //  if (counter == maxCount) {
  //    println("clearing");
  //    clear();
  //    counter++;
  //  }
  //  for (int i = 0; i < 100; i++)
  //    arr[i].remove();
      
  //  for (int i = 0; i < arr.length; i++) {
  //    arr[i].drawDot();
  //  }
  //}
  
  if (fCounter++ % 5 == 0);
    saveFrame("movie/capture-####.png");
  
}

void swap(int a, int b) {
  int pom = a;
  a = b;
  b = pom;
}

void swap(float a, float b) {
  float pom = a;
  a = b;
  b = pom;
}

void randomEllipse() {
  
  noStroke();
  fill(0);
  
  float wh = random(minRadius, maxRadius);
  int whvalue = int(wh);
  
  // get random x axis point; need to figure out how to test bounds outside or touching window
  float x = random(0, width);
  int xx = int(x);
  
  // get random y axis point; need to figure out how to test bounds outside or touching window
  float y = random(0, height);
  int yy= int(y);
  
  ellipse(xx, yy, whvalue, whvalue);
}

public class Dot {
  
  public boolean hasShadow;
  public float radius;
  private int shadowOffset;
  public float x;
  public float y;
  public boolean valid;
  public float speed;
  public PVector closestPixel;
  public float pct;
  public float beginX;
  public float beginY;
  public float step;
  public color col;
  
  public Dot() {
    this.hasShadow = true;
    this.radius = random(minRadius, maxRadius);
    this.shadowOffset = globalShadowOffset;
    this.valid = true;
    this.pct = 0;
    this.beginX = -1;
    this.beginY = -1;
    this.step = globalStep;
    this.col = color(#000000);
  }
  
  public Dot(float radius) {
    this.hasShadow = true;
    this.radius = radius;
    this.shadowOffset = globalShadowOffset;
    this.valid = true;
    this.pct = 0;
    this.beginX = -1;
    this.beginY = -1;
    this.step = globalStep;
    this.col = color(#000000);
  }
  
  public void drawDot() {
    if (!this.valid) return;
    fill(0);
    //this.renderShadow(x, y, shadowOffset);
    fill(col);
    ellipse(this.x, this.y, this.radius, this.radius);
  }
  
  public void redrawAt(float x, float y) {
    this.x = x;
    this.y = y;
    drawDot();
  }
  
  public void render() {
    if (!this.valid) return;
    this.x = random(radius * 2, width - radius * 2);
    this.y = random(radius * 2, height - radius * 2);
    if (this.beginX == -1)
      this.beginX = this.x;
    if (this.beginY == -1)
      this.beginY = this.y;
    fill(0);
    //this.renderShadow(x, y, shadowOffset);
    fill(col);
    ellipse(x, y, this.radius, this.radius);
  }
  
  private void renderShadow(float x, float y, float shadowOffset) {
    if (!this.valid) return;
    fill(0, 0, 0, 200);
    ellipse(x + shadowOffset, y + shadowOffset, 
      this.radius * shadowSize, this.radius * shadowSize);
  }
  
  public void remove() {
    this.valid = false;
  }
  
}

void keyPressed() {
  if (key == 's') saveFrame("capture-####.png");
}